from quart import Blueprint, jsonify, request
from applications.service import GetCoverService

from tasks.task_scheduler import TaskScheduler

server_blueprint = Blueprint("api", __name__, url_prefix="/api")


def server_routes(pools):

    @server_blueprint.route("/get_cover", methods=["POST"])
    async def get_cover():
        params = await request.get_json()
        task = GetCoverService(pools, params)
        return jsonify(await task.deal())

    @server_blueprint.route("/run_task", methods=["POST"])
    async def run_task():
        data = await request.get_json()
        task_scheduler = TaskScheduler(data)
        response = await task_scheduler.deal()
        return jsonify(response)

    return server_blueprint
